package jcsc;

/**
 * gFNXpvZ̒`
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.0  26 May 2007
 */
public class ExtColorCalc {

	/**
	 * RGBHSVϊ
	 * @param color
	 */
	public static void toHSV(ExtColor exc){
		int h, s, v;

		int i,j;
		int m;
		int[] e  = new int[3];
		int[] id = new int[3];
		for(i=0; i<3; i++) id[i] = i;

		e[0] = exc.color.getRed();
		e[1] = exc.color.getGreen();
		e[2] = exc.color.getBlue();

		for(i=1; i<3; i++){
			for(j=0; j<i; j++){
				if(e[i-j] > e[i-j-1]){
					m = e[i-j];
					e[i-j] = e[i-j-1];
					e[i-j-1] = m;
					m = id[i-j];
					id[i-j] = id[i-j-1];
					id[i-j-1] = m;
				} else break;
			}
		}

		if(e[0] == 0){
			h = s = v = 0;

		} else {
			v = e[0];

			s = 255-e[2]*255/e[0];
			if(s == 0){
				h = 0;
			} else {
				if((id[0]-id[1]+2)%2 == 0){
					if(id[0]-id[1]>0) i = 1; else i = -1;
				} else {
					if(id[0]-id[1]<0) i = 1; else i = -1;
				}
				h = ((512*id[0] + i*(e[1]-e[2])*255/(e[0]-e[2]) +1536) % 1536)/6;
			}
		}

		exc.h = h;
		exc.s = s;
		exc.v = v;
	}

}

/*
//HSVRGB
void HSVtoRGB(
unsigned char h,unsigned char s,unsigned char v,
unsigned char &r,unsigned char &g,unsigned char &b)
{

		int i;
		unsigned char e[3];
		unsigned char id[3];

		e[0] = v;
		e[2] = (255-s)*v/255;
		e[1] = e[2]+(e[0]-e[2])*abs((h*6+256)%512-256)/255;

		for(i=0; i<3; i++) id[i] = abs(256*3-(h*6+256*(3+i*2))%1536)/256;

		r = e[id[0]];
		g = e[id[1]];
		b = e[id[2]];

}
*/