package jte;

import java.io.File;

import javax.swing.filechooser.FileFilter;

/**
 * jtet@CtB^
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.1  14 Apr.2007
 */
 class CustomizedFileFilter extends FileFilter {
	 public String extension;

	 /**
	  * RXgN^
	  *   @param extension
	  */
	 public CustomizedFileFilter(String extension){
		 this.extension = extension;
	 }

	 /**
	  * accept\bh
	  *   @param f t@C
	  */
	 public boolean accept(File f) {
		 if (f != null) {
			 if (f.isDirectory()) return true;
	
			 String extension = getExtension(f);
			 System.out.println(f.getName()+" -> "+extension);
			 if (extension == null) return false;
			 if (extension.compareTo(this.extension) == 0) return true;
		 }
		 return false;
	 }

	 /**
	  * gqo
	  *   @param f t@C
	  *   @return gq
	  */
	 public String getExtension(File f) {
		 if(f != null) {
			 String filename = f.getName();
			 int i = filename.lastIndexOf('.');
			 if(i>0 && i<filename.length()-1) {
				 return filename.substring(i+1).toLowerCase();
			 }
		 }
		 return null;
	 }

	 public String getDescription(){
		StringBuffer s = new StringBuffer();
		s.append(PropertyManage.applicationname);
		s.append(" file (*.");
		s.append(PropertyManage.extension);
		s.append(")");
		return s.toString();
	 }
 }
