package jte;

import java.awt.Image;
import java.awt.Toolkit;
import java.util.Hashtable;

/**
 * 摜[_
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.1  14 Apr.2007
 */
public class ImageLoader {

	public ImageLoader() {
	}

	public Hashtable<String, Image> load(String imagedir, String[] imagefiles) {
		Hashtable<String, Image> images = new Hashtable<String, Image>();
		for (int i = 0; i < imagefiles.length; i++) {
			Image currentimage = Toolkit.getDefaultToolkit().
				getImage(
				getClass().getClassLoader().getResource(
				imagedir + imagefiles[i] + ".png"
				));
			images.put(imagefiles[i], currentimage);
		}
		return images;
	}
}

