
package jte;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

/**
 * ŋߊJt@CXg
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.1  8 Jul.2007
 */
public class RecentFiles {
	private List<String> filelist = null;
	private int maxsize = 0;

	/**
	 * RXgN^
	 */
	public RecentFiles() {
		filelist = new ArrayList<String>();
	}
	
	public RecentFiles(int n) {
		maxsize = n;
		filelist = new ArrayList<String>(n);
	}

	/**
	 * XgTCY̕ύX
	 * @param n
	 */
	public void changeSize(int n) {
		maxsize = n;
	}
	
	/**
	 * TCYԂ
	 * @return
	 */
	public int size() {
		return filelist.size();
	}
	
	/**
	 * nԖڂ𓾂
	 * @param n
	 * @return
	 */
	public String get(int n) {
		if (n >= filelist.size()) {
			return null;
		} else { 
			return (String)filelist.get(n);
		}
	}

	/**
	 * nԖڂ̃t@CԂ
	 * @param n
	 * @return
	 */
	public String getName(int n) {
		String fn;

		fn = get(n);
		if (fn == null) return null;

		File f = new File(fn);
		return f.getName();
	}

	/**
	 * |bv
	 * @return
	 */	
	public String pop() {
		return get(0);
	}

	/**
	 * vbV
	 * @param s
	 */
	public void push(String s) {
		int i;

		// ovf폜
		for (i = 0; i < filelist.size(); i++) {
			if (s.equals((String)filelist.get(i))) {
				filelist.remove(i);
				break;
			} 
		}

		// 擪ɑ}
		filelist.add(0, s);
		
		// TCYI[o[̗vf
		if (filelist.size() > maxsize) {
			for (i = filelist.size()-1; i >= maxsize; i--) {
				filelist.remove(i);		
			}
		}
	}

}
