package jte.mainframe;

import java.awt.Insets;
import java.io.File;
import java.util.Locale;

import javax.swing.BoxLayout;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.CompoundBorder;
import javax.swing.border.EmptyBorder;
import javax.swing.border.TitledBorder;

import jte.Common;
import jte.ResourceManage;

/**
 * Xe[^Xo[
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.1  14 Apr.2007
 */
public class StatusBar extends JPanel {
	JTextField tf[];

	/**
	 * RXgN^
	 * @param resm
	 * @param propm
	 * @param cmn
	 */
	public StatusBar() {
		setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
		setBorder(new CompoundBorder(
			new TitledBorder(null, null,
			TitledBorder.CENTER, TitledBorder.BOTTOM),
			new EmptyBorder(0,0,0,0)));

		tf = new JTextField[4];

		for (int n = 0; n < 4; n++) {
			tf[n] = new JTextField();
			tf[n].setEditable(false);
			tf[n].setBorder(new EmptyBorder(new Insets(0,0,0,0)));
			add(tf[n]);
		}

		refresh();
	}

	/**
	 * tbV
	 */
	public void refresh() {
		File path = new File(Common.getListios().getName());
		StringBuffer s = new StringBuffer(path.getName());
		if (Common.isFileChanged()) {
			s.append(ResourceManage.getString("listchanged"));
		} 
		tf[0].setText(s.toString());
		tf[2].setText(Common.getTangram().getLocalPuzzleName(Locale.getDefault().getISO3Language()));
		tf[3].setText(Integer.toString(Common.getListios().getCount()));
	}
}
