package jte.mainframe;

import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JProgressBar;
import javax.swing.JToolBar;

import jte.Common;
import jte.ResourceManage;

/**
 * c[o[
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.1  14 Apr.2007
 */
public class ToolBar extends JToolBar implements ActionListener {
	private final boolean DEBUG = false;			// fobOp

	public JProgressBar progbar;
	//private JButton ddopen;
	//private JButton ddkind;
	private JButton kindbt;

	/**
	 * RXgN^
	 * @param resm
	 * @param propm
	 * @param cmn
	 */
	public ToolBar() {
		add(createButton("new", this));
		add(createButton("open", this));
		//add(ddopen = createButton("dropdown", this));
		//ddopen.setToolTipText(ResourceManage.getString("file.ddopen"));
		add(createButton("save", this));
		addSeparator();
		add(kindbt = createButton("kind", this));
		//add(ddkind = createButton("dropdown", this));
		//ddkind.setToolTipText(ResourceManage.getString("file.ddkind"));

		progbar = new JProgressBar(0, 100);
		progbar.setVisible(false);
		add(progbar);

	}

	/**
	 * {^̐
	 * @param name
	 * @param tb
	 * @return
	 */
	private JButton createButton(String name, ToolBar tb) {
		JButton bt = new JButton("",
			new ImageIcon(ResourceManage.getImage(name)));
		bt.setBorderPainted(false);
		bt.setRolloverEnabled(true);
		bt.setMargin(new Insets(0,0,0,0));
		bt.setFocusable(false);
		bt.setText(null);
		bt.setToolTipText(ResourceManage.getString("file." + name));
		bt.setActionCommand("file." + name);
		bt.addActionListener(tb);
		return bt;
	}

	/**
	 * ANVfBXpb`
	 */
	public void actionPerformed(ActionEvent e) {
		String command = e.getActionCommand();
		if (DEBUG) System.out.println(command);

		if (e.getSource() instanceof JButton) {
			if (command.equals("file.new")) { Common.actionFileNew(); return; }
			if (command.equals("file.open")) { Common.actionFileOpen(null); return; }
			if (command.equals("file.kind")) { Common.actionFileKind(); return; }
			if (command.equals("file.saveas")) { Common.actionFileSaveAs(); return; }
			if (command.equals("file.save")) { Common.actionFileSave(); return; }
		}
	}	

	/**
	 * tbV
	 */
	public void refresh() {
		kindbt.setEnabled((Common.getListCount() <= 0) && (!Common.isFileChanged()));
		//ddkind.setEnabled((Common.getListCount() <= 0) && (!Common.isFileChanged()));

		//ddkind.setEnabled(false);
		//ddopen.setEnabled(false);
	}
}
