package jvdtanapp.listpanel;

import java.awt.*;
import java.awt.event.*;
import jvdtanapp.*;
import tangram.svcs.*;
import tangram.*;

/**
 * VGbgXgGUINX
 *   @(#)ListGUI.class
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.0  11 Mar.2006
 */
public class ListGUI {
	Common comm;

	private Listios lios;
	private Imgs imgs;
	private Tangram tan;

	public int bufWidth = 0;
	public int bufHeight = 0;

	private int xarr[];
	private int yarr[];
	private int idxarr[];
	private int lstidx = -1;
	private int lstcnt = -1;
	private int forcusedidx = -1;

	final double itvl[] = {0, 62, 42, 10};
	final double sz[] = {40, 30, 8, 8};
	final int   isz[] = {40, 30, 8, 8};
	final int  hisz[] = {20, 15, 4, 4};

	/**
	 * RXgN^
	 *   @param comm ʃNX
	 *   @param tan ^O
	 *   @param lios VGbgXgIOT[rX
	 */
	public ListGUI(Common comm, Tangram tan, Listios lios) {
		this.comm = comm;

		this.tan = tan; 
		this.lios = lios;

		imgs = new Imgs();
		comm.setjvdtImgsparam(imgs);
	}

	/**
	 * ʃTCYZbg
	 *   @param w ʕ
	 *   @param h ʍ
	 */
	public void setSize(int w, int h) {
		bufWidth  = w;
		bufHeight = h;

		makeposindex();
	}

	/**
	 * ACRɃ}EXڂĂ邩`FbN
	 *   @param e }EXCxg
	 *   @return ωtrue
	 */
	public boolean judgeForcused(MouseEvent e){
		int x = e.getX();
		int y = e.getY();

		int oldfcsidx = forcusedidx;

		forcusedidx = -1;
		for (int i = 0; i < lstcnt; i++) {
			int d = Math.abs(idxarr[i] - lstidx);
			// ͈͂̔ɂ́A2hbg̗]T
			if (d > 2) {
				if (Math.abs(x - xarr[i]) < hisz[3] + 2 &&
					Math.abs(y - yarr[i]) < hisz[3] + 2)
					forcusedidx = idxarr[i];
			} else {
				if (Math.abs(x - xarr[i]) < hisz[d] + 2 &&
					Math.abs(y - yarr[i]) < hisz[d] + 2)
					forcusedidx = idxarr[i];
			}
		}
		return (forcusedidx != oldfcsidx);
	}

	/**
	 * tH[JXĂVGbgɈړ
	 *   @return ړłǂ
	 */
	public boolean moveToForcusedidx(){
		boolean ret = lios.moveIndexTo(forcusedidx);
		if (ret) makeposindex();
		return ret;
	}

	/**
	 * tH[JXĂCfbNXԂ
	 *   @return CfbNX
	 */
	public int getForcusedIndex(){
		return forcusedidx;
	}

	/**
	 * Jg̃CfbNXԂ
	 *   @return CfbNX
	 */
	public int getCurrentIndex(){
		return lstidx;
	}

	/**
	 * VGbgXg̕`
	 *   @param g2 `
	 */
	public void paint(Graphics2D g2){
		// Xg̃p[^ωĂzČvZ
		if (lstidx != lios.getIndex() ||
			lstcnt != lios.getCount())
			makeposindex();

		PieceInfo pi = new PieceInfo();

		double ratio = imgs.ratio;
		double slide_x = imgs.slide_x;
		double slide_y = imgs.slide_y;

		for (int i = 0; i < lstcnt; i++) {
			int d = Math.abs(idxarr[i] - lstidx);
			// ̂
			if (d > 2) {
				// tH[JXĂꍇ́AnCCg{VGbg\
				if (idxarr[i] == forcusedidx) {
					PieceInfoTool.copy(pi, lios.get(idxarr[i]));
					g2.setColor(comm.List_NameColor);
					g2.drawString((idxarr[i] + 1) + "." + pi.name,
									xarr[i] + hisz[3] + 4, yarr[i] + 6);
					g2.setColor(comm.List_BGColor);
					g2.fillRect(xarr[i] - hisz[3], yarr[i] - hisz[3], isz[3], isz[3]);				
					g2.setColor(comm.List_FrameColor);
					g2.setStroke(comm.defaultLine_Stroke);
					g2.drawRect(xarr[i] - hisz[3], yarr[i] - hisz[3], isz[3], isz[3]);				
				// ȊO͖{ɔ
				} else {
					g2.setColor(comm.List_FrameColor);
					g2.setStroke(comm.defaultLine_Stroke);
					g2.drawRect(xarr[i] - hisz[3], yarr[i] - hisz[3], isz[3], isz[3]);				
				}
			// JgƂ̑O̓VGbg`悷
			} else {
				// tH[JXĂꍇ́AnCCg
				if (idxarr[i] == forcusedidx) {
					g2.setColor(comm.List_HLBGColor);
				} else {
					g2.setColor(comm.List_BGColor);
				}
				g2.fillRect(xarr[i] - hisz[d], yarr[i] - hisz[d], isz[d], isz[d]);
				g2.setColor(comm.List_FrameColor);
				g2.setStroke(comm.defaultLine_Stroke);
				g2.drawRect(xarr[i] - hisz[d], yarr[i] - hisz[d], isz[d], isz[d]);				

				// VGbg`
				PieceInfoTool.copy(pi, lios.get(idxarr[i]));
				if (d <= 1) {
					imgs.setRatio((d == 0) ? 0.15 : 0.1);
					imgs.setSlide(
						xarr[i] - (int)(PieceInfoTool.getXAverage(pi) * imgs.ratio),
						yarr[i] - (int)(PieceInfoTool.getYAverage(pi) * imgs.ratio));
					imgs.drawPieces(g2, tan.geombank, pi, tan.piext, PieceInfoExt.MODE_ALL,
									true, false, true, null);
					// n
					imgs.setRatio(ratio);
					imgs.setSlide((int)slide_x, (int)slide_y);
				}
				// VGbg\
				g2.setColor(comm.List_NameColor);
				g2.drawString((idxarr[i] + 1) + "." + pi.name,
								xarr[i] + hisz[d] + 4, yarr[i] + 6);
			}
		}
	}

	/**
	 * WƃCfbNXz̍ČvZ
	 */
	private void makeposindex() {
		lstcnt = lios.getCount();
		lstidx = lios.getIndex();
		xarr = new int[lstcnt];
		yarr = new int[lstcnt];
		idxarr = new int[lstcnt];

		double ys = 30;
		double ye = (double)bufHeight - 30;
		double H = ye - ys;
		double adjH = (H == 0) ? 1 : H;
	
		int cnt = lstcnt;
		int idx = lstidx;
	
		// ŒC^[oŕ\̂邩𒲂ׂ
		double fixH = 0;
		int fixcnt = 1;
		for (int i = 1; i < 4; i++) {
			if (idx + i < cnt) { fixH += itvl[i]; fixcnt++; } 
			if (idx - i >= 0)  { fixH += itvl[i]; fixcnt++; } 
		}

		int fcnt = cnt - fixcnt;

		// C^[o̎Zo
		double fitvl = itvl[3];	
		if (H - fixH > (double)fcnt * itvl[3]) {
			// ʂ̍\ΌŒC^[oŔzu
			ye = ys + fixH + (double)fcnt * itvl[3];
		} else {
			// ʂꍇ́A𓙕Ĕzu
			fitvl = (H - fixH) / (double)fcnt;
		}
	
		// fobO\
		if (false) System.out.println("H=" + H + ", fixH=" + fixH);
		if (false) System.out.println("fixcnt=" + fixcnt + ", fcnt=" + fcnt + ", fitvl=" + fitvl);
	
		double y;
		int p;
		int ap = 0;
			
		// ŌWvZn߂
		y = ye;
		for(p = cnt - 1;; p--){
			if (p <= idx + 2) break;
			xarr[ap] = 40 + (int)(20 * Math.sin(2 * Math.PI * (y - 50) / adjH));
			yarr[ap] = (int)y;
			idxarr[ap] = p;
			ap++;
			y -= fitvl;
		}
	
		// ɐ擪WvZ
		y = ys;
		for(p = 0;; p++){
			if (p >= idx - 2) break;
			xarr[ap] = 40 + (int)(20 * Math.sin(2 * Math.PI * (y - 50) / adjH));
			yarr[ap] = (int)y;
			idxarr[ap] = p;
			ap++;
			y += fitvl;
		}
	
		// ŌɌŒC^[ô̂̍WvZ
		y += itvl[3] - fitvl;
		for (; p <= idx + 2; p++) {
			if (p < 0) continue;
			if (p >= cnt) break;
	
			int j = p - idx, k;
			if (j < 0)	{ k = -j; j = k; }
				else	{ k = j;  j++;   }

			xarr[ap] = 40 + (int)(20 * Math.sin(2 * Math.PI * (y - 50) / adjH));
			yarr[ap] = (int)y;
			idxarr[ap] = p;
			ap++;
			y += itvl[j];
		}
	}
}
