package jvdtanapp.menupanel;

import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;
import jvdtanapp.*;
import jvdtanapp.menupanel.pathicon.*;

/**
 * j[plNX
 *   @(#)MenuPanel.class
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.0  4 Nov.2006
 */
public class MenuPanel
		extends JPanel
		implements  MouseListener,
					MouseMotionListener {

	Common comm;
	MainFrame mf;

	public PathIconManager pim;			// vCpl̃pXACRǗNX

	private GeneralPath sepgp;			// Zp[^̌`

	/**
	 * RXgN^
	 *   @param comm ʃNX
	 *   @param mf eNX
	 */
	public MenuPanel(Common comm, MainFrame mf) {
		this.comm = comm;
		this.mf = mf;

		pim			= new PathIconManager(comm);
	
		addMouseMotionListener(this);
		addMouseListener(this);

		setDoubleBuffered(true);
		setPreferredSize(new Dimension(0, 72));
		setMinimumSize(getPreferredSize());

		int sepx = 68;
		int sepd = 1;
		sepgp = new GeneralPath();
		sepgp.moveTo(0, 0);
		sepgp.lineTo(sepx+sepd*30, 0);
		sepgp.curveTo(sepx+sepd*10, 0, sepx, 20, sepx, 30);
		sepgp.lineTo(sepx, 42);
		sepgp.curveTo(sepx, 62, sepx-sepd*20, 72, sepx-sepd*30, 72);
		sepgp.lineTo(0, 72);
		sepgp.lineTo(0, 0);
	}

	/**
	 * ʂ`
	 *   @param g `
	 */
	private int bufWidth = 0;
	private int bufHeight = 0;
	public void paint(Graphics g) {
		Graphics2D g2 = (Graphics2D)g;

		// TCY
		if (getWidth() != bufWidth ||
			getHeight() != bufHeight) {
				bufWidth = getSize().width;
				bufHeight = getSize().height;

			pim.relocate(bufWidth, bufHeight);		// pXACRĔzu

		}

		g2.setColor(comm.menuPanel_BGColor);
		g2.fillRect(0, 0, bufWidth, bufHeight);

		Common.setAA(g2);

		g2.setColor(comm.listPanel_BGColor);
		g2.fill(sepgp);

		// pXACR`
		pim.paint(g2);
	}

	/**
	 * }EXXi[Q
	 *   @param e }EXCxg
	 */
	public void mouseDragged(MouseEvent e) {
	}

	/**
	 * {^ꂽ
	 *   @param e }EXCxg
	 */
	public void mousePressed(MouseEvent e) {
		if (pim.action(e)) {
			repaint();
		}
	}

	/**
	 * {^ꂽ
	 *   @param e }EXCxg
	 */
	public void mouseReleased(MouseEvent e) {
	}

	/**
	 * }EXړ
	 *   @param e }EXCxg
	 */
	public void mouseMoved(MouseEvent e) {
		if (pim.judgeForcused(e)) {
			repaint();
		}
	}

	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {
		if (pim.judgeForcused(e)) {
			repaint();
		}
	}
	public void mouseClicked(MouseEvent e) {}

}
