package jvdtanapp.menupanel.pathicon;

import java.awt.*;
import java.util.*;
import java.awt.event.MouseEvent;

import jvdtanapp.*;

/**
 * pXACRǗNX
 *   @(#)PathIconManager.class
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.0  11 Mar.2006
 */
public class PathIconManager {
	Common comm;

	public java.util.List<PathIcon> PathIcons;
	private PathIcon piNew;
	private PathIcon piOpen;
	private PathIcon piSave;
	private PathIcon piBreak;
	private PathIcon piAdd;
	private PathIcon piCenter;
	private PathIcon piGuide;
	private PathIcon piUndo;
	private PathIcon piRedo;
	private PathIcon piDustbox;

	/**
	 * RXgN^
	 *   @param comm ʃNX
	 */
	public PathIconManager(Common comm){
		this.comm = comm;

		PathIcons = new ArrayList<PathIcon>(10);

		piNew = (PathIcon)(new PINew(comm));
		PathIcons.add(piNew);

		piOpen = (PathIcon)(new PIOpen(comm));
		PathIcons.add(piOpen);

		piSave = (PathIcon)(new PISave(comm));
		if (comm.isApplet) piSave.disable();
		PathIcons.add(piSave);

		piBreak = (PathIcon)(new PIBreak(comm));
		PathIcons.add(piBreak);

		piAdd = (PathIcon)(new PIAdd(comm));
		PathIcons.add(piAdd);

		piCenter = (PathIcon)(new PICenter(comm));
		PathIcons.add(piCenter);

		piGuide = (PathIcon)(new PIGuide(comm));
		PathIcons.add(piGuide);

		piUndo = (PathIcon)(new PIUndo(comm));
		PathIcons.add(piUndo);

		piRedo = (PathIcon)(new PIRedo(comm));
		PathIcons.add(piRedo);

		piDustbox = (PathIcon)(new PIDustbox(comm));
		PathIcons.add(piDustbox);
	}

	/**
	 * pXACR̍Ĕzu
	 *   @param w pl̕
	 *   @param h pl̍
	 */
	public void relocate(int w, int h){
		double pos;
		
		pos = (double)30;
		piDustbox.x = pos;

		pos = (double)w - 35;
		piNew.x 	= pos; pos -= 50;
		piOpen.x 	= pos; pos -= 50;
		piSave.x 	= pos; pos -= 50;
		piAdd.x 	= pos; pos -= 50;
		piCenter.x 	= pos; pos -= 50;
		piBreak.x 	= pos; pos -= 50;
		piGuide.x 	= pos; pos -= 50;
		piRedo.x 	= pos; pos -= 50;
		piUndo.x 	= pos; pos -= 50;

		for (Iterator<PathIcon> pii = PathIcons.iterator(); pii.hasNext();) {
			PathIcon pi = (PathIcon)pii.next();
			pi.y = (double)h - 30;
		}
	}

	/**
	 * pXACR̕`
	 *   @param g2 `
	 */
	public void paint(Graphics2D g2){
		for (Iterator<PathIcon> pii = PathIcons.iterator(); pii.hasNext();) {
			PathIcon pi = (PathIcon)pii.next();
			pi.drawPathIcon(g2);
		}
	}

	/**
	 * ACRɃ}EXڂĂ邩`FbN
	 *   @param e }EXCxg
	 *   @return ωtrue
	 */
	public boolean judgeForcused(MouseEvent e){
		boolean changed = false;
		for (Iterator<PathIcon> pii = PathIcons.iterator(); pii.hasNext();) {
			PathIcon pi = (PathIcon)pii.next();
			changed |= pi.judgeForcused(e);

			if (pi.isForcused()) break;
		}
		return changed;
	}

	/**
	 * tH[JXĂACR̃ANVs
	 *   @param e }EXCxg
	 *   @return ANVsꂽtrue
	 */
	public boolean action(MouseEvent e){
		for (Iterator<PathIcon> pii = PathIcons.iterator(); pii.hasNext();) {
			PathIcon pi = (PathIcon)pii.next();
			if (pi.isForcused()) {
				pi.callAction();
				return true;
			}
		}
		return false;
	}
}
