package tangram;

/**
 * `\vf
 *   @(#)GeomPoint.class
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.0  11 Mar.2006
 */
public class GeomPoint {

	// \vf̎ʎq
	public static final int PATH_MOVETO  =  0;
	public static final int PATH_LINETO  =  1;
	public static final int PATH_QUADTO  =  2;
	public static final int PATH_CURVETO =  3;

	public int kind;	// \vf̎
	public double x[];	// \vfxWQ
	public double y[];	// \vfyWQ
	public int num;		// W

	/**
	 * RXgN^
	 */
	public GeomPoint() {
		init();
	}

	/**
	 * RXgN^
	 *   1g̍Wɂ\
	 *   @param kd \vf̎ʎq
	 *   @param px xW
	 *   @param py yW
	 */
	public GeomPoint(int kd, double px, double py) {
		init();
		kind = kd;
		x[0] = px;
		y[0] = py;
		num = 1;
	}

	/**
	 * RXgN^
	 *   2g̍Wɂ\
	 *   @param kd \vf̎ʎq
	 *   @param px1 xW1
	 *   @param py1 yW1
	 *   @param px2 xW2
	 *   @param py2 yW2
	 */
	public GeomPoint(int kd, double px1, double py1,
							 double px2, double py2) {
		init();
		kind = kd;
		x[0] = px1;
		y[0] = py1;
		x[1] = px2;
		y[1] = py2;
		num = 2;
	}

	/**
	 * RXgN^
	 *   3g̍Wɂ\
	 *   @param kd \vf̎ʎq
	 *   @param px1 xW1
	 *   @param py1 yW1
	 *   @param px2 xW2
	 *   @param py2 yW2
	 *   @param px3 xW3
	 *   @param py3 yW3
	 */
	public GeomPoint(int kd, double px1, double py1,
							 double px2, double py2,
							 double px3, double py3) {
		init();
		kind = kd;
		x[0] = px1;
		y[0] = py1;
		x[1] = px2;
		y[1] = py2;
		x[2] = px3;
		y[2] = py3;
		num = 3;
	}

	/**
	 * 
	 *   3g̍Wzm
	 */
	private void init() {
		kind = 0;
		x = new double[3];
		y = new double[3];
		num = 0;
	}
}
