package tangram.svcs;

import java.util.*;
import tangram.PieceInfo;

/**
 * VGbgXg
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.0  11 Mar.2006
 *   @version  0.1  25 Mar.2007
 */
public class SilhouetteList {
	private List<PieceInfo> sillist = null;
	private String name = null;
	private String newname = "New Correction";
	
	/**
	 * RXgN^
	 */
	public SilhouetteList() {
		name = newname;
		sillist = new ArrayList<PieceInfo>(10);
	}

	/**
	 * RXgN^
	 * @param newname
	 */
	public SilhouetteList(String newname) {
		this.newname = newname;
		name = newname;
		sillist = new ArrayList<PieceInfo>(10);
	}

	/**
	 * Xg̃NA
	 */
	public void clear() {
		name = newname;
		sillist.clear();
	}

	/**
	 * VKXg̃Zbg
	 * @param newname
	 */
	public void setNewName(String newname) {
		String oldname = this.newname;
		this.newname = newname;
		if (name == oldname) {
			name = newname;
		}
	}

	/**
	 * Xgɒǉ
	 *   @param pi ǉPieceInfo
	 */
	public void add(PieceInfo pi) {
		sillist.add(pi);
	}

	/**
	 * Xg̎wʒuɒǉ
	 *   @param n ǉʒu
	 *   @param pi ǉPieceInfo
	 */
	public void add(int n, PieceInfo pi) {
		sillist.add(n, pi);
	}

	/**
	 * wʒu̗vf폜
	 *   @param n 폜ʒu
	 */
	public void delete(int n) {
		sillist.remove(n);
	}

	/**
	 * Xg̒Ԃ
	 *   @return Xg̒
	 */
	public int getCount() {
		return sillist.size();
	}

	/**
	 * Xg̖Oݒ
	 *   @param s Xg̖Oiۂɂ̓t@Cj
	 */
	public void setName(String s) {
		name = s.toString();
	}

	/**
	 * Xg̖O擾
	 *   @return Xg̖O
	 */
	public String getName() {
		return name.toString();
	}

	/**
	 * XĝVGbgo
	 *   @param n CfbNX
	 */
	public PieceInfo get(int n) {
		if (n >= 0 || n < sillist.size()) return (PieceInfo)sillist.get(n);
		return null;
	}
}
