package jvdtanapp;

import org.w3c.dom.*;
import javax.xml.parsers.*;
import java.io.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.filechooser.FileFilter;
import acolor.*;
import jvdtanapp.listpanel.*;
import jvdtanapp.menupanel.*;
import jvdtanapp.playpanel.*;
import jvdtanapp.statuspanel.*;
import tangram.svcs.*;
import tangram.*;

/**
 * ʃNX
 *   @(#)Common.class
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.0  11 Mar.2006
 */
public class Common {
	public boolean isApplet;

	MainFrame mf;
	Tangram tan;
	Listios lios;
	Imgs imgs;
	Undom um;
	ListPanel lp;
	MenuPanel mp;
	PlayPanel pp;
	StatusPanel sp;

	// fobO
	public static final boolean DEBUG_ = false;	// }X^[
	public static final boolean DEBUG_Common = DEBUG_ && true;
	public static final boolean DEBUG_PlayPanel = DEBUG_ && true;
	public static final boolean DEBUG_BufferManager = DEBUG_ && true;

	// ^O
	public static final String NewSilhouette = "New Silhouette";
	public static final String NewCorrection = "New Correction";
	public static boolean vertexAttach = true;
	
	// KCh
	public boolean GuideDispSW = false;
	public Color Guide_solidLine_Color = new Color(128, 112, 112, 255);
	public Stroke Guide_solidLine_Stroke =
		new BasicStroke(3.5f, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL);
	public Stroke Guide_bulkLine_Stroke =
		new BasicStroke(2.0f, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL);

	// AhD[
	public int maxundonum = 100;

	// A`GCAX
	public static final boolean AntiAliasing = true;

	// \[X
	public static final String jvdtanExtension = "jte";
	public static String resCurrentDirectory = "res";
	private int resindex = 0;
	private int idxnum = 0;
	private String flst[];

	// Ct[
	public static String defaultTanResource =
							resCurrentDirectory + "/" + "default." + jvdtanExtension;

	// Xe[^Xpl
	public Color statusPanel_BGColor = new Color(255, 255, 255, 255);
	public Color statusPanel_FWColor = new Color(0, 0, 0, 255);

	// Cpl
	public boolean rippleEnable = false;	// g`ǂ
	public boolean checkerBoard = false;	// nɃ`FbJ[͗lgǂ
	public Color listPanel_BGColor = new Color(255, 255, 255, 255);
	public Color menuPanel_BGColor = new Color(255, 255, 255, 255);
	public Color playPanel_BGColor = new Color(255, 255, 255, 255);

	// ^O`T[rX
	public Color pieces_Color = new Color(0, 0, 0, 255);
	public Color dottedLine_Color = new Color(0, 0, 0, 180);
	public Stroke dottedLine_Stroke =
		new BasicStroke(2.0f, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL,
						0, new float[]{1,4}, 0);
	public Stroke dashedLine_Stroke =
		new BasicStroke(1.0f, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL,
						0, new float[]{4,4}, 0);
	public Stroke solidLine_Stroke =
		new BasicStroke(1.0f, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL);

	// XgGUI
	public Stroke defaultLine_Stroke =
		new BasicStroke(1.0f);

	// Xg
	public Color List_BGColor	// obNJ[
		= new Color(255, 255, 255, 128);
	public Color List_HLBGColor	// nCCgobNJ[
		= new Color(255, 255, 255, 190);
	public Color List_FrameColor	// t[J[
		= new Color(0, 0, 0, 64);
	public Color List_NameColor	// l[J[
		= new Color(0, 0, 64, 80);
	public Font List_NameFont	// l[tHg
		= new Font("Sherif", Font.PLAIN, 12);

	// pXACR
	public Color pathIcon_EdgeColor	// GbWJ[
		= new Color(255, 255, 255, 255);
	public Color pathIcon_DisableEdgeColor
		= new Color(255, 255, 255, 255);
	public Color pathIcon_LineColor	// CJ[
		= new Color(0, 0, 0, 255);
	public Color pathIcon_DisableLineColor
		= new Color(0, 0, 0, 128);
	public Color pathIcon_SlashColor	// XbVCJ[
		= new Color(255, 0, 0, 80);
	public Color pathIcon_NameColor	// l[J[
		= new Color(0, 0, 64, 80);
	public Font pathIcon_NameFont	// l[tHg
		= new Font("Sherif", Font.PLAIN, 12);

/*
 * 
 */
	/**
	 * RXgN^
	 *   @param mf eNXiCt[j
	 */
	public Common(MainFrame mf) {
		this.mf = mf;
		isApplet = mf.isApplet;
	}

	/**
	 * vpeB[XMLݒǂݍ
	 */
	public void initProperties(){
		String s = "jvdtanapp.property";

		try {
			// hLgr_[t@Ng𐶐
			DocumentBuilderFactory dbfactory = DocumentBuilderFactory.newInstance();

			// hLgr_[𐶐
			DocumentBuilder builder = dbfactory.newDocumentBuilder();

			// p[XsDocumentIuWFNg擾
			Document doc;
			if (isApplet) {
				// \[Xǂݍ
				doc = builder.parse(getClass().getClassLoader().getResourceAsStream(s));
			} else {
				// t@CVXeǂݍ
				doc = builder.parse(new File(s));
			}
			// [gvf擾
			Element root = doc.getDocumentElement();
			if (root == null) return;
			if (root.getTagName().compareTo("jvdtanapp") != 0) return;

			NodeList nlist;
			Element elem;
			int r, g, b;

			// JgfBNg
			nlist = root.getElementsByTagName("resCurrentDirectory");
			if (nlist.getLength() > 0) {
				elem = (Element)nlist.item(nlist.getLength() - 1);
				resCurrentDirectory = elem.getAttribute("dir");
				defaultTanResource = resCurrentDirectory + "/" + "default." + jvdtanExtension;
			}

			// fBtHg\[Xt@C
			nlist = root.getElementsByTagName("defaultTanResource");
			if (nlist.getLength() > 0) {
				elem = (Element)nlist.item(nlist.getLength() - 1);
				defaultTanResource = resCurrentDirectory + "/" +
										elem.getAttribute("name") + "." + jvdtanExtension;
			}

			// \[Xt@CAC
			nlist = root.getElementsByTagName("resourceforApplet");
			if (nlist.getLength() > 0) {
				flst = new String[nlist.getLength()];
				idxnum = nlist.getLength();
				for (int i = 0; i < idxnum; i++) {
					elem = (Element)nlist.item(i);
					flst[i] = resCurrentDirectory + "/"
								+ elem.getAttribute("name") + "." + jvdtanExtension;
				}
			} else {
				flst = new String[1];
				flst[0] = defaultTanResource;
				idxnum = 1;
			}

			// gON/OFF
			nlist = root.getElementsByTagName("rippleEnable");
			if (nlist.getLength() > 0) {
				elem = (Element)nlist.item(nlist.getLength() - 1);
				rippleEnable = ("true".compareTo(elem.getAttribute("enabled")) == 0);
			}

			// _WON/OFF
			nlist = root.getElementsByTagName("vertexAttach");
			if (nlist.getLength() > 0) {
				elem = (Element)nlist.item(nlist.getLength() - 1);
				vertexAttach = ("true".compareTo(elem.getAttribute("enabled")) == 0);
			}

			// őAhD[Gg[
			nlist = root.getElementsByTagName("maxUndonum");
			if (nlist.getLength() > 0) {
				elem = (Element)nlist.item(nlist.getLength() - 1);
				maxundonum = Integer.parseInt(elem.getAttribute("n"));
			}

			// F`
			nlist = root.getElementsByTagName("listPanel_BGColor");
			if (nlist.getLength() > 0) {
				elem = (Element)nlist.item(nlist.getLength() - 1);
				r = g = b = 0;
				r = Integer.parseInt(elem.getAttribute("r"));
				g = Integer.parseInt(elem.getAttribute("g"));
				b = Integer.parseInt(elem.getAttribute("b"));
				listPanel_BGColor = new Color(r, g, b, 255);
			}

			nlist = root.getElementsByTagName("menuPanel_BGColor");
			if (nlist.getLength() > 0) {
				elem = (Element)nlist.item(nlist.getLength() - 1);
				r = g = b = 0;
				r = Integer.parseInt(elem.getAttribute("r"));
				g = Integer.parseInt(elem.getAttribute("g"));
				b = Integer.parseInt(elem.getAttribute("b"));
				menuPanel_BGColor = new Color(r, g, b, 255);
			}

			nlist = root.getElementsByTagName("playPanel_BGColor");
			if (nlist.getLength() > 0) {
				elem = (Element)nlist.item(nlist.getLength() - 1);
				r = g = b = 0;
				r = Integer.parseInt(elem.getAttribute("r"));
				g = Integer.parseInt(elem.getAttribute("g"));
				b = Integer.parseInt(elem.getAttribute("b"));
				playPanel_BGColor = new Color(r, g, b, 255);
			}

			nlist = root.getElementsByTagName("pieces_Color");
			if (nlist.getLength() > 0) {
				elem = (Element)nlist.item(nlist.getLength() - 1);
				r = g = b = 0;
				r = Integer.parseInt(elem.getAttribute("r"));
				g = Integer.parseInt(elem.getAttribute("g"));
				b = Integer.parseInt(elem.getAttribute("b"));
				pieces_Color = new Color(r, g, b, 255);
			}

			nlist = root.getElementsByTagName("Guide_solidLine_Color");
			if (nlist.getLength() > 0) {
				elem = (Element)nlist.item(nlist.getLength() - 1);
				r = g = b = 0;
				r = Integer.parseInt(elem.getAttribute("r"));
				g = Integer.parseInt(elem.getAttribute("g"));
				b = Integer.parseInt(elem.getAttribute("b"));
				Guide_solidLine_Color = new Color(r, g, b, 255);
			}

			nlist = root.getElementsByTagName("NameColor");
			if (nlist.getLength() > 0) {
				elem = (Element)nlist.item(nlist.getLength() - 1);
				r = g = b = 0;
				r = Integer.parseInt(elem.getAttribute("r"));
				g = Integer.parseInt(elem.getAttribute("g"));
				b = Integer.parseInt(elem.getAttribute("b"));
				List_NameColor = new Color(r, g, b, 80);
				pathIcon_NameColor = new Color(r, g, b, 80);
			}
		} catch (Exception e) {
			e.printStackTrace();
			return;
		}

	}

	/**
	 * ^O`T[rXɃp[^Zbg
	 *   @param imgs ^O`T[rX
	 */
	public void setjvdtImgsparam(Imgs imgs) {
		imgs.setPiecesColor(pieces_Color);
		imgs.setPiecesColord(pieces_Color);
		imgs.setDottedLineColor(dottedLine_Color);
		imgs.setDottedLineStroke(dottedLine_Stroke);
		imgs.setDashedLineStroke(dashedLine_Stroke);
		imgs.setSolidLineStroke(solidLine_Stroke);
		imgs.setAntiAliasing(AntiAliasing);
	}

	/**
	 * ^OIy[VT[rXɃp[^Zbg
	 *   @param Opes ^OIy[VT[rX
	 */
	public void setjvdtOpesparam(Opes opes) {
		opes.setVertexAttach(vertexAttach);
	}

	/**
	 * ^OZbg
	 *   @param tan ^O
	 */
	public void setTan(Tangram tan) {
		this.tan = tan;
	}

	/**
	 * ^OXgIOT[rXZbg
	 *   @param lios ^OXgIO
	 */
	public void setLios(Listios lios) {
		this.lios = lios;
	}

	/**
	 * ^O`T[rXZbg
	 *   @param imgs ^O`T[rX
	 */
	public void setImgs(Imgs imgs) {
		this.imgs = imgs;
	}

	/**
	 * AhD[}l[W[Zbg
	 *   @param um AhD[}l[W[
	 */
	public void setUm(Undom um) {
		this.um = um;
	}

	/**
	 * Xgplo^
	 *   @param lp vCpl
	 */
	public void setLp(ListPanel lp) {
		this.lp = lp;
	}

	/**
	 * j[plo^
	 *   @param pp vCpl
	 */
	public void setMp(MenuPanel mp) {
		this.mp = mp;
	}

	/**
	 * vCplo^
	 *   @param pp vCpl
	 */
	public void setPp(PlayPanel pp) {
		this.pp = pp;
	}

	/**
	 * Xe[^Xplo^
	 *   @param sp vCpl
	 */
	public void setSp(StatusPanel sp) {
		this.sp = sp;
	}

	/**
	 * Xe[^XplXV
	 */
	public void refreshStatusPanel() {
		sp.resourcename.setText(lios.getName() + " (" + tan.getPuzzleName() + ")");
		sp.nameinput.setText(tan.getName());
	}

	/**
	 * XgplXV
	 */
	public void refreshListPanel() {
		lp.repaint();
	}

	/**
	 * j[plXV
	 */
	public void refreshMenuPanel() {
		mp.repaint();
	}

	/**
	 * vCplXV
	 */
	public void refreshPlayPanel() {
		pp.repaint();
	}

	/**
	 * FzF
	 *   @param c F
	 */
	public void setColorSet(Color c){
		int r[] = new int[9];
		int g[] = new int[9];
		int b[] = new int[9];
		for (int i = 0; i < 9; i++){
			Color x = AColor.GetMatchColor(c, i - 1);
			r[i] = x.getRed();
			g[i] = x.getGreen();
			b[i] = x.getBlue();
		}

		int i;

		// Xe[^Xpl
		i = 6; statusPanel_BGColor = new Color(r[i], g[i], b[i], 255);
		i = 8; statusPanel_FWColor = new Color(r[i], g[i], b[i], 255);

		// obt@}l[W[
		i = 0; listPanel_BGColor = new Color(r[i], g[i], b[i], 255);
		i = 0; menuPanel_BGColor = new Color(r[i], g[i], b[i], 255);
		i = 0; playPanel_BGColor = new Color(r[i], g[i], b[i], 255);

		// ^O`T[rX
		i = 3; pieces_Color = new Color(r[i], g[i], b[i], 255);
		i = 3; dottedLine_Color = new Color(r[i], g[i], b[i], 180);

		// Xg
		i = 1; List_BGColor	// obNJ[
			= new Color(r[i], g[i], b[i], 128);
		i = 2; List_HLBGColor	// nCCgobNJ[
			= new Color(r[i], g[i], b[i], 190);
		i = 7; List_FrameColor	// t[J[
			= new Color(r[i], g[i], b[i], 64);
		i = 6; List_NameColor	// l[J[
			= new Color(r[i], g[i], b[i], 80);

		// pXACR
		i = 7; pathIcon_EdgeColor	// GbWJ[
			= new Color(r[i], g[i], b[i], 255);
		pathIcon_DisableEdgeColor
			= new Color(r[i], g[i], b[i], 228);
		i = 6; pathIcon_LineColor	// CJ[
			= new Color(r[i], g[i], b[i], 255);
		pathIcon_DisableLineColor
			= new Color(r[i], g[i], b[i], 255);
		i = 3; pathIcon_SlashColor	// XbVCJ[
			= new Color(r[i], g[i], b[i], 80);
		i = 6; pathIcon_NameColor	// l[J[
			= new Color(r[i], g[i], b[i], 80);
	}

	/**
	 * A`GCAXݒ
	 *   @param g2 Kp
	 */
	public static void setAA(Graphics2D g2) {
		if (Common.AntiAliasing) {
			g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, 
								RenderingHints.VALUE_ANTIALIAS_ON);
		} else {
			g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, 
								RenderingHints.VALUE_ANTIALIAS_OFF);
		}
	}

/*
 * ANVR}hQ
 */
	/**
	 * VKW
	 *   @return Ȃtrue
	 */
	public boolean actionFileNew() {
		lios.clear();
		lios.setName(NewCorrection);
		refreshStatusPanel();
		refreshListPanel();
		refreshPlayPanel();

		actionEditBreak();
		return true;
	}

/**
 * I[v
 *   @return Ȃtrue
 */
	public boolean actionFileOpen() {
		boolean ret = false;
	
		if (! isApplet) {
			// t@Cǂݍ
			JFileChooser chooser = new JFileChooser();
			chooser.setCurrentDirectory(new File(resCurrentDirectory));
			chooser.setFileFilter(new jvdtanFileFilter(jvdtanExtension));
			int retval = chooser.showOpenDialog(mf.f);
			if (retval == JFileChooser.APPROVE_OPTION) {
				String path = chooser.getSelectedFile().getPath();
				String name = chooser.getSelectedFile().getName();
				if (DEBUG_Common)
					System.out.println("You chose to open this file: " + path);
	
				ret = lios.loadXML(tan, path, false, false);
				lios.setName(name);	// pX͏ȗ
	
			} else {
				// LZ̏ꍇAԂ
				refreshMenuPanel();
				return true;
			}
		} else {
			// \[Xǂݍ
			if (false){
				// restH_jvdtant@CTi\[Xǂݍ݂ł͖j
				File f = new File(resCurrentDirectory);
				File[] flst = f.listFiles();
				jvdtanFileFilter fflt = new jvdtanFileFilter(jvdtanExtension);
	
				int idx = 0;
				for (int i = 0; i < flst.length; i++){
					if ((! flst[i].isDirectory()) && fflt.accept(flst[i]))
						flst[idx++] = flst[i];
				}
				if (resindex >= idx) resindex = 0;
				ret = lios.loadXML(tan, flst[resindex++].getPath(), false, true);
			} else {
				// \[Xz񂩂w肷
				if (idxnum == 0) return false;
				if (resindex >= idxnum) resindex = 0;
				System.out.println(flst[resindex]);
				ret = lios.loadXML(tan, flst[resindex++], false, true);
			}
		}
	
		if (! ret) lios.setName(NewCorrection);
		refreshStatusPanel();
		refreshListPanel();
		refreshMenuPanel();
			
		um.adpreset(tan);
		actionEditBreak();
		return ret;
	}

	/**
	 * Z[u
	 *   @return Ȃtrue
	 */
	public boolean actionFileSave() {
		boolean ret = false;
	
		if (! isApplet) {
			// t@C֏
			JFileChooser chooser = new JFileChooser();
			chooser.setCurrentDirectory(new File(resCurrentDirectory));
			chooser.setFileFilter(new jvdtanFileFilter(jvdtanExtension));
			chooser.setSelectedFile(new File(lios.getName()));
			int retval = chooser.showSaveDialog(mf.f);
			if (retval == JFileChooser.APPROVE_OPTION) {
				File f = chooser.getSelectedFile();
				String path = f.getPath();
				String name = f.getName();

				jvdtanFileFilter fflt = new jvdtanFileFilter(jvdtanExtension);
				if ((! f.isDirectory()) && (! fflt.accept(f))){
					path += "." + jvdtanExtension;
					name += "." + jvdtanExtension;
				}

				if (DEBUG_Common)
					System.out.println("You chose to save this file: " + path);

				ret = lios.saveXML(tan, path, false);
				if (ret) lios.setName(name);	// pX͏ȗ

				refreshStatusPanel();
	
			} else {
				// LZ̏ꍇAԂ
				refreshMenuPanel();
				return true;
			}
		}
		
		refreshMenuPanel();
		return ret;
	}

	/**
	 * Xg^OփVGbgn
	 *   @return Ȃtrue
	 */
	public boolean actionEditEdit(int n) {
		PieceInfo pi = lios.get(n);
		if (pi == null) return false;

		tan.importPinfo(pi);
		refreshStatusPanel();
		refreshPlayPanel();

		actionEditEntry();
		return true;
	}

	public boolean actionEditEdit() {
		if (lp.getCurrentIndex() >= 0) {
			return actionEditEdit(lp.getCurrentIndex());
		}

		return false;
	}	

	/**
	 * VGbg̃KCh̐؂ւ
	 *   @return Ȃtrue
	 */
	public boolean actionOptionGuide() {
		if (lios.getIndex() < 0 || lios.getCount() < 1) {
			return true;
		}
		GuideDispSW = !GuideDispSW;
		refreshPlayPanel();
		return true;
	}

	/**
	 * VGbg̃Z^O
	 *   @return Ȃtrue
	 */
	public boolean actionEditCenter() {
		tan.activeAll();
		tan.move(-tan.getActivesOriginX(), -tan.getActivesOriginY());
		tan.sleepAll();
		refreshPlayPanel();

		actionEditEntry();
		return true;
	}

	/**
	 * VGbg̃u[N
	 *   @return Ȃtrue
	 */
	public boolean actionEditBreak() {
		tan.breakup();
		tan.setName(NewSilhouette);
		refreshStatusPanel();
		refreshPlayPanel();

		actionEditEntry();
		return true;
	}

	/**
	 * AhD[obt@ɃGg[
	 */
	public void actionEditEntry() {
		tan.setName(sp.nameinput.getText());
		um.entry(tan);
	}

	public void actionEditEntry(PieceInfo pi) {
		um.entry(pi);
	}

	/**
	 * AhD[
	 *   @return Ȃtrue
	 */
	public boolean actionEditUndo() {
		um.undo(tan);
		refreshStatusPanel();
		refreshPlayPanel();
		return true;
	}

	/**
	 * hD[
	 *   @return Ȃtrue
	 */
	public boolean actionEditRedo() {
		um.redo(tan);
		refreshStatusPanel();
		refreshPlayPanel();
		return true;
	}

	/**
	 * Xg̃CfbNXړ
	 *   @param n CfbNXω
	 *   @return Ȃtrue
	 */
	public boolean actionListMoveIndex(int n) {
		if (lios.moveIndex(n)) {
			refreshListPanel();
			return true;
		}
		
		return false; 
	}

	/**
	 * Xgɒǉ
	 *   @return Ȃtrue
	 */
	public boolean actionEditAdd() {
		if (DEBUG_Common) System.out.println(PieceInfoTool.toString(tan.pinfo));

		lios.add(sp.nameinput.getText(), tan.exportPinfo());
		refreshListPanel();
		return true;
	}

	/**
	 * Xg폜
	 *   @return Ȃtrue
	 */
	public boolean actionEditDelete() {
		PieceInfo pi = lios.get(lios.getIndex());
		if (pi == null) return false;
		if (DEBUG_Common) System.out.println("Common Delete");
		lios.delete();
		refreshListPanel();

		um.virtualUndo();
		um.entry(pi);
		um.entry(tan);

		return true;
	}
}

/*
 * jvdtant@CtB^[
 */
class jvdtanFileFilter extends FileFilter {
	private String jvdtanExtension;

	/**
	 * RXgN^
	 *   @param extension
	 */
	public jvdtanFileFilter(String extension){
		jvdtanExtension = extension;
	}

	/**
	 * accept\bh
	 *   @param f t@C
	 */
	public boolean accept(File f) {
		if (f != null) {
			if (f.isDirectory()) return true;
	
			String extension = getExtension(f);
			if (extension == null) return false;
			if (extension.compareTo(jvdtanExtension) == 0) return true;
		}
		return false;
	}

	/**
	 * gqo
	 *   @param f t@C
	 *   @return gq
	 */
	public String getExtension(File f) {
		if(f != null) {
			String filename = f.getName();
			int i = filename.lastIndexOf('.');
			if(i>0 && i<filename.length()-1)
				return filename.substring(i+1).toLowerCase();
		}
		return null;
	}

	public String getDescription(){
		return "javade tangram file(*.jvdtan)";
	}
}
