package jvdtanapp;

import java.awt.*;
import javax.swing.*;
import jvdtanapp.listpanel.*;
import jvdtanapp.menupanel.*;
import jvdtanapp.playpanel.*;
import jvdtanapp.statuspanel.*;
import tangram.svcs.*;
import tangram.*;

/**
 * javade tangram̃Ct[
 *   @(#)MainFrame.class
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.0  11 Mar.2006
 */
public class MainFrame extends JPanel {
	public Common comm;
	
	private JPanel mainpanel;
	public ListPanel listpanel;
	public MenuPanel menupanel;
	public PlayPanel playpanel;

	public StatusPanel statuspanel;

	public Tangram tan;
	public Listios lios;
	public Undom um;

	public boolean isApplet;
	public JFrame f;

	/** 
	 * javade tangram̃Ct[쐬
	 *   @param isApplet AvbgƂċNꂽǂ
	 */
	public MainFrame(JFrame f, boolean isApplet) {
		this.f = f;
		this.isApplet = isApplet;

		setLayout(new BorderLayout());

		// ʃNX
		comm = new Common(this);
		comm.initProperties();

		// ^O
		tan = new Tangram();		// GeomBank
		lios = new Listios();	// SilhouetteList

		// AhD[}l[W[
		um = new Undom(comm.maxundonum);
		um.reset(tan);
		um.entry(tan);

		// Cpl
		mainpanel = new JPanel();
		mainpanel.setLayout(new BorderLayout());
		listpanel = new ListPanel(comm, this);
		menupanel = new MenuPanel(comm, this);
		playpanel = new PlayPanel(comm, this);
		mainpanel.add("West", listpanel);
		mainpanel.add("South", menupanel);
		mainpanel.add("Center", playpanel);
		add("Center", mainpanel);

		// Xe[^Xpl
		statuspanel = new StatusPanel(comm, this);
		add("South", statuspanel);

		comm.setTan(tan);
		comm.setLios(lios);
		comm.setUm(um);
		comm.setLp(listpanel);
		comm.setMp(menupanel);
		comm.setPp(playpanel);
		comm.setSp(statuspanel);

		if (isApplet)
			if (! lios.loadXML(tan, Common.defaultTanResource, false, true))
				lios.setName(Common.NewCorrection);

		comm.refreshStatusPanel();
	}
}
