package jvdtanapp.listpanel;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import jvdtanapp.*;
import tangram.svcs.*;
import tangram.*;

/**
 * XgplNX
 *   @(#)ListPanel.class
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.0  4 Nov.2006
 */
public class ListPanel
		extends JPanel
		implements  MouseListener,
					MouseMotionListener,
					MouseWheelListener {

	Common comm;
	MainFrame mf;

	public ListGUI lgui;				// VGbgXg`NX

	public Tangram tan;
	public Listios lios;

	/**
	 * RXgN^
	 *   @param comm ʃNX
	 *   @param mf eNX
	 */
	public ListPanel(Common comm, MainFrame mf) {
		this.comm = comm;
		this.mf = mf;

		tan = mf.tan;
		lios = mf.lios;

		lgui		= new ListGUI(comm, tan, lios);

		addMouseMotionListener(this);
		addMouseListener(this);
		addMouseWheelListener(this);

		setDoubleBuffered(true);
		setPreferredSize(new Dimension(192, 0));
		setMinimumSize(getPreferredSize());
	}

	/**
	 * Jg̃CfbNXԂ
	 *   @return CfbNX
	 */
	public int getCurrentIndex(){
		return lgui.getCurrentIndex();
	}

	/**
	 * ʂ`
	 *   @param g `
	 */
	private int bufWidth = 0;
	private int bufHeight = 0;
	public void paint(Graphics g) {
		Graphics2D g2 = (Graphics2D)g;

		// TCY
		if (getWidth() != bufWidth ||
			getHeight() != bufHeight) {
				bufWidth = getSize().width;
				bufHeight = getSize().height;

				lgui.setSize(bufWidth, bufHeight);		// ListDrawerɉʃTCYʒm
		}

		g2.setColor(comm.listPanel_BGColor);
		g2.fillRect(0, 0, bufWidth, bufHeight);

		// VGbgXg`
		Common.setAA(g2);
		lgui.paint(g2);
	}

	/**
	 * }EXXi[Q
	 *   @param e }EXCxg
	 */
	public void mouseDragged(MouseEvent e) {
	}

	/**
	 * {^ꂽ
	 *   @param e }EXCxg
	 */
	public void mousePressed(MouseEvent e) {
		// zC[{^ŃGfBbg
		if (e.getButton() == MouseEvent.BUTTON2) {
			if (lgui.getCurrentIndex() >= 0) {
				comm.actionEditEdit(lgui.getCurrentIndex());
				return;
			}
		}

		// Xg̃tH[JXĂCfbNXɈړ
		if (lgui.moveToForcusedidx()) {
			lgui.judgeForcused(e);
			comm.refreshPlayPanel();
			repaint();
			return;
		} else {
			// CfbNXƈvĂ׏ɍڂ
			if(lgui.getForcusedIndex() >= 0) {
				comm.actionEditEdit(lgui.getForcusedIndex());
				repaint();
				return;
			}
		}
	}

	/**
	 * {^ꂽ
	 *   @param e }EXCxg
	 */
	public void mouseReleased(MouseEvent e) {
	}

	/**
	 * }EXړ
	 *   @param e }EXCxg
	 */
	public void mouseMoved(MouseEvent e) {
		if (lgui.judgeForcused(e)) {
			repaint();
		}
	}

	/**
	 * }EXzC[Cxg
	 *   @param e }EXCxg
	 */
	public void mouseWheelMoved(MouseWheelEvent e) {
		if (comm.actionListMoveIndex(e.getWheelRotation())) {
			comm.refreshPlayPanel();
			repaint();
		}
	}

	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {}
}
