package tangram;

import java.util.*;

/**
 * {}`NX
 *   @(#)GeomElem.class
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.0  11 Mar.2006
 */
public class GeomElem {

	public String id;			// {}`̖
	public List<GeomPoint> geompoints;		// WXg
	public double local_ox;		// SxW
	public double local_oy;		// SyW
	public double charlen;		// 

	/**
	 * RXgN^
	 */
	public GeomElem() {
		geompoints = new ArrayList<GeomPoint>(20);
		clear();
	}

	/**
	 * RXgN^
	 *   IDƒSWw肵ď
	 * @param s }`̖O
	 * @param ox SxW
	 * @param oy SyW
	 */
	public GeomElem(String s, double ox, double oy) {
		id = s.toString();
		geompoints = new ArrayList<GeomPoint>(20);
		local_ox = ox;
		local_oy = oy;
	}

	/**
	 * }`NA
	 */
	public void clear() {
		geompoints.clear();
		id = "";
		local_ox = 0;
		local_oy = 0;
		charlen = 1.0;
	}

	/**
	 * SWZbg
	 *   @param ox SxW
	 *   @param oy SyW
	 */
	public void setLocalOrigin(double ox, double oy) {
		local_ox = ox;
		local_oy = oy;
	}

	/**
	 * }`̖̂Zbg
	 *   @param s }`̖
	 */
	// 
	public void setId(String s) {
		id = s.toString();
	}

	/**
	 * }`̖̂ƒSWZbg
	 *   @param s }`̖
	 *   @param ox SxW
	 *   @param oy SyW
	 */
	public void set(String s, double ox, double oy) {
		setId(s);
		setLocalOrigin(ox, oy);
	}

	/**
	 * `\vfǉ
	 *   @param gp ǉ`\vf
	 */
	public void add(GeomPoint gp) {
		geompoints.add(gp);

		// ̍XV
		for (int i = 0; i < gp.num; i++) {
			double l = Math.sqrt(  Math.pow(gp.x[i] - local_ox, 2)
								 + Math.pow(gp.y[i] - local_oy, 2));
			if (l > charlen) charlen = l;
		}
	}

	/**
	 * `\vf̐Ԃ
	 *   @return `\vf̐
	 */
	public int count() {
		return geompoints.size();
	}

}
