package tangram;

/**
 * VGbg̃s[X
 *   @(#)PieceInfoExt.class
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.0  11 Mar.2006
 */
public class PieceInfoExt {
	public static final int MODE_SLEEP  = 0x01;
	public static final int MODE_ACTIVE = 0x02;
	public static final int MODE_ALL    = 0xff;

	public int[] order;				// s[X̏
	public int[] mode;				// 샂[h

	/**
	 * RXgN^ 
	 */
	public PieceInfoExt() {
	}

	/**
	 * RXgN^ 
	 *   PieceInfo琶
	 *   @param pinfo
	 */
	public PieceInfoExt(PieceInfo pinfo) {
		init(pinfo);
	}

	/**
	 * PieceInfoŏ
	 *   @param pinfo
	 */
	public void init(PieceInfo pinfo) {
		order = new int[pinfo.num];
		mode  = new int[pinfo.num];

		initOrder();
		sleepAll();
	}

	/**
	 * ̏
	 */
	public void initOrder() {
		for (int i = 0; i < order.length; i++) order[i] = i;
	}

	/**
	 * ԍñs[XX[vԂɂ
	 *   @param n s[Xԍ
	 */
	public void sleepOne(int n) {
		mode[n]  = MODE_SLEEP;
	}

	/**
	 * SẴs[XX[vԂɂ
	 */
	public void sleepAll() {
		for (int i = 0; i < mode.length; i++) mode[i]  = MODE_SLEEP;
	}

	/**
	 * ԍñs[XANeBuԂɂ
	 *   @param n s[Xԍ
	 */
	public void activeOne(int n) {
		mode[n]  = MODE_ACTIVE;
	}

	/**
	 * SẴs[XANeBuԂɂ
	 */
	public void activeAll() {
		for (int i = 0; i < mode.length; i++) mode[i]  = MODE_ACTIVE;
	}
}
